function varargout=plotmesh(self,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('color',self.color);
  p.addParamValue('Tag',self.Tag);
  p.parse(varargin{:});
  R=p.Results;
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
%    idx=cellfun(@(x) ismember(upper(x),upper({'EdgeColor','FaceColor'})),{varargin{1:2:end}},'UniformOutput',false);
%    idx=find([idx{:}]);
%    for i=idx, varargin{2*i}=fc_tools.graphics.xcolor.val2rgb(varargin{2*i},'check',false); end
  varargin=fc_tools.graphics.xcolor.color_varargin(varargin,{'EdgeColor','FaceColor'});
  H=eval(sprintf('PlotSubTh%dsimp%dD(self,fc_tools.graphics.xcolor.val2rgb(R.color),R.Tag,varargin)',self.d,self.dim));
  if nargout==1,varargout{1}=H;end
end

function h=PlotSubTh3simp3D(self,Color,Tag,varargin)
  varargin=varargin{:};
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('cutPlan',[]);
  p.parse(varargin{:});
  P=p.Results.cutPlan;
  PlotOptions=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  view(3)
  idxme=self.cutIndex(P);
%    if ~isempty(P)
%      Point=[0;0;-P(4)];
%      idx=find(P(1:3)*(self.q-Point*ones(1,self.nq))>0);
%      idxme=find(sum(ismember(self.me,idx),1)==0);
%    else
%      idxme=1:self.nme;
%    end
  if fc_tools.comp.isOctave()
    T=self.me(:,idxme)';
    triang = [T(:, 1) T(:, 2) T(:, 3); ...
              T(:, 2) T(:, 3) T(:, 4); ...
              T(:, 3) T(:, 4) T(:, 1); ...
              T(:, 4) T(:, 1) T(:, 2)];
    if isempty(P)
      h=patch('faces',triang,'vertices',self.q','FaceColor','none', ...
                'EdgeColor',Color,'Tag',Tag,PlotOptions{:});
    else
      h=patch('faces',triang,'vertices',self.q','FaceColor',Color, ...
                'Tag',Tag,PlotOptions{:});
    end
  else
    if isempty(P)
      idx=nchoosek(1:4,2);
      ME=[];
      for i=1:size(idx,1) % speedup with patch insteed of tetramesh?
        ME=[ME;self.me(idx(i,:),idxme)'];
      end
      h=patch('Vertices',self.q','Faces',ME,'EdgeColor',Color,'FaceColor','none','Tag',Tag,PlotOptions{:});
    else
      T=self.me(:,idxme)';
      triang = [T(:, 1) T(:, 2) T(:, 3); ...
              T(:, 2) T(:, 3) T(:, 4); ...
              T(:, 3) T(:, 4) T(:, 1); ...
              T(:, 4) T(:, 1) T(:, 2)];
      h=patch('Vertices',self.q','Faces',triang,'FaceColor',Color,'Tag',Tag,PlotOptions{:});
    end
  end
end

function h1=PlotSubTh2simp3D(self,Color,Tag,varargin)
  varargin=varargin{:};
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('cutPlan',[]);
  p.parse(varargin{:});
  P=p.Results.cutPlan;
  PlotOptions=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  idxme=cutIndex(self,P);
  q=self.q;
  h=trimesh(self.me(:,idxme)',q(1,:),q(2,:),q(3,:),'EdgeColor','k','faceColor',Color,'Tag',Tag,PlotOptions{:});
  Q=[0 0 0;1 0 0;0 1 0];ME=[1 2 3];
  h1=trimesh(ME,Q(:,1),Q(:,2),Q(:,3),'EdgeColor','k','faceColor',Color,'Tag',Tag,PlotOptions{:},'Visible','Off');
end

function h=PlotSubTh1simp3D(self,Color,Tag,varargin)
  varargin=varargin{:};
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('cutPlan',[]);
  p.parse(varargin{:});
  P=p.Results.cutPlan;
  PlotOptions=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  idxme=cutIndex(self,P);n=length(idxme);
  X=[self.q(1,self.me(1,idxme));self.q(1,self.me(2,idxme));NaN(1,n)];
  Y=[self.q(2,self.me(1,idxme));self.q(2,self.me(2,idxme));NaN(1,n)];
  Z=[self.q(3,self.me(1,idxme));self.q(3,self.me(2,idxme));NaN(1,n)];
  H=plot3(X(:),Y(:),Z(:),'Color',Color,'Tag',Tag,PlotOptions{:});
  h=H;
end

function h=PlotSubTh0simp3D(self,Color,Tag,PlotOptions)
  h=plot3(self.q(1),self.q(2),self.q(3),'LineStyle','none','Marker','o','MarkerFaceColor',Color','Color',Color,'Tag',Tag,PlotOptions{:});
end

function h=PlotSubTh2simp2D(self,Color,Tag,PlotOptions)
  q=self.q;
  H=triplot(self.me',q(1,:),q(2,:),'Color',Color,'Tag',Tag,PlotOptions{:});
  h=H(1);
end

function h=PlotSubTh1simp2D(self,Color,Tag,PlotOptions)
  X=[self.q(1,self.me(1,:));self.q(1,self.me(2,:));NaN(1,self.nme)];
  Y=[self.q(2,self.me(1,:));self.q(2,self.me(2,:));NaN(1,self.nme)];
  h=plot(X(:),Y(:),'Color',Color,'Tag',Tag,PlotOptions{:}); 
end

function h=PlotSubTh0simp2D(self,Color,Tag,PlotOptions)
  h=plot(self.q(1),self.q(2),'LineStyle','none','Marker','o','MarkerFaceColor',Color','Color',Color,'Tag',Tag,PlotOptions{:});
end

function h=PlotSubTh1simp1D(self,Color,Tag,PlotOptions)
  h=line(self.q(1,self.me(1,:)),zeros(self.nme,1),'Color',Color,'Tag',Tag,PlotOptions{:}); 
end

function h=PlotSubTh0simp1D(self,Color,Tag,PlotOptions)
  h=plot(self.q(1),self.q(2),'LineStyle','none','Marker','o','MarkerFaceColor',Color','Color',Color,'Tag',Tag,PlotOptions{:});
end
